POJ 1151 Atlantis

2024-01-26 09:38
文章标签 poj atlantis 1151

本文主要是介绍POJ 1151 Atlantis,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

首先,我得吐个槽。陶叔果然是个诚实的孩子,今天的题简直坑爆了好么?

先说A题,翻了一遍题目,觉得A题(SPOJ SUB_PROB)就是个KMP的模板题,心中大喜,套模板,欲A之,怎奈何居然是WA(我还提交了三遍T_T,再不济你给个TLE我也可以接受啊)。于是重新读题,发现应该拿AC自动机来搞!!!瞄一眼Rank,分析一下局势,决定不理A题了,开了E题(Aizu 0024)。

由于E题是签到水题(按照陶叔的话来说,什么是签到题捏?签到题就是你A了以后能证明你来了的题~),果断AC。接着顺手开了F题(CodeForces 81A),发现F题也很水,是道堆栈的模拟题,以前有做过类似的题目,轻松A掉。看看表才过了不到一个小时,暗自感叹今天运气还是不错滴,喝口水,养个神,开D题(UVA 10319)。

由于英语太渣,读题貌似出现了错误,天真的以为是DFS,开心的码完代码,提交,WA。正在郁闷的时候,看到了陶叔良心发现在公告里给了Hint,尼玛,2-SAT!思路差了八十条街,而且最坑爹的是,我读错题的DFS样例居然过了!于是心情默默的不好了,关了OJ,开始各种骚扰刘文蔚学长。。。。。。

比完赛之后仔细看了看,其实C题(SPOJ RATING)挺好搞的,就是题目写得不是特别顺眼,一开始要是选这道的话,还是有可能A掉的~

好吧,吐完槽了,开始写正经东西,线段树的离散化和扫描线。

POJ上有一道题很经典,算是线段树的进阶吧,大家一起来看一下。

Description

There are several ancient Greek texts that contain descriptions of the fabled island Atlantis. Some of these texts even include maps of parts of the island. But unfortunately, these maps describe different regions of Atlantis. Your friend Bill has to know the total area for which maps exist. You (unwisely) volunteered to write a program that calculates this quantity.

Input

The input consists of several test cases. Each test case starts with a line containing a single integer n (1 <= n <= 100) of available maps. The n following lines describe one map each. Each of these lines contains four numbers x1;y1;x2;y2 (0 <= x1 < x2 <= 100000;0 <= y1 < y2 <= 100000), not necessarily integers. The values (x1; y1) and (x2;y2) are the coordinates of the top-left resp. bottom-right corner of the mapped area.
The input file is terminated by a line containing a single 0. Don't process it.

Output

For each test case, your program should output one section. The first line of each section must be "Test case #k", where k is the number of the test case (starting with 1). The second one must be "Total explored area: a", where a is the total explored area (i.e. the area of the union of all rectangles in this test case), printed exact to two digits to the right of the decimal point.
Output a blank line after each test case.

Sample Input

2
10 10 20 20
15 15 25 25.5
0

Sample Output

Test case #1
Total explored area: 180.00 

Source

Mid-Central European Regional Contest 2000

题目意思很简单,就是让你求矩形的面积,重合的部分只算一次。解题的步骤大体来说分为三步:

1)输入数据,建树。

2)离散化:将所有的x轴坐标存在一个数组里。

3)扫描线:从下到上扫描,更新区间计数。

图片来自:红黑联盟-kk303




下面是完整的代码:

#include<iostream>
#include<stdio.h>
#include<string.h>
#include<algorithm>
#define MAXN 405
using namespace std;struct node
{double l,r,y;//左端点,右端点,y轴高度int tp;//上下水平线标记bool operator < (node a) const// < 运算符重载,sort函数使用{return y < a.y;}
}line[MAXN << 2];int n;
double X[MAXN << 2],Times[MAXN << 2],sum[MAXN];int b_search(double x)//区间查找
{int l,r,mid;l = 0,r = n + 1;while (r - l > 1){mid=(l + r) >> 1;if (X[mid] <= x) l = mid;else r = mid;}return l;//返回离散化的区间
}void update(int x,int c,int l,int r,int now)
{if (l == r){Times[x] += c;//区间计数修改if (Times[x]) sum[now]=X[x+1]-X[x]; //若区间计数为正,得到区间长度if (!Times[x]) sum[now]=0;//若区间计数为零,不计入长度return;}int mid = (l + r )/ 2;if (x <= mid) update(x,c,l,mid,now << 1);if (mid < x)  update(x,c,mid + 1,r,(now << 1) | 1);sum[now] = sum[now << 1] + sum[(now << 1) | 1];return;
}
int main()
{int i,j,T=0;double ans=0;while (~scanf("%d",&n) && n){int num=0;for (i=1;i<=n;i++){double x1,y1,x2,y2;scanf("%lf%lf%lf%lf",&x1,&y1,&x2,&y2);//录入矩形的对角线端点line[i*2-1].y = y1;//矩形水平线的y轴坐标line[i*2-1].l = x1;//水平线的左端点line[i*2-1].r = x2;//水平线的右端点line[i*2-1].tp = 1;//下水平线标记line[i*2].y = y2;//矩形水平线的y轴坐标line[i*2].l = x1;//水平线的左端点line[i*2].r = x2;//水平线的右端点line[i*2].tp = -1;//上水平线标记X[++num]=x1;//矩阵的左端点X[++num]=x2;//矩阵的右端点}ans = 0;n = n * 2;//每个矩阵都有上下水平线sort(X + 1,X + 1 + num);//将所有X坐标从小到大排序sort(line + 1,line + 1 + n);//将所有line按Y坐标从小到大排序memset(sum,0,sizeof(sum));//扫描线扫到的合法长度memset(Times,0,sizeof(Times));//区间的计数数组for (i = 1;i <= n;i++){ans += sum[1] * (line[i].y - line[i - 1].y);//面积 = 每一段合法长度 * 高度int l,r;l = b_search(line[i].l);//离散化,获取区间r = b_search(line[i].r) - 1;//离散化,获取区间for (j = l;j <= r;j++)update(j,line[i].tp,1,n-1,1);//扫描线更新操作}printf("Test case #%d\nTotal explored area: %.2f\n\n",++T,ans);}return 0;
}


这篇关于POJ 1151 Atlantis的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/646390

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i